<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Overview</title>
    <detaileddescription>
<para>Cypress MQTT library provides an easy-to-use APIs for Cypress devices to connect with cloud MQTT brokers and perform MQTT publish and subscribe operations.</para>
<para><heading level="1">Library Components</heading></para>
<para>This MQTT library consists of two components: 1) AWS IoT Device SDK library 2) Platform porting layer</para><para>AWS IoT Device SDK library is an open source library and it uses the platform porting layer functions to perform MQTT operations. Hence, the application that uses this library should invoke the AWS IoT Device SDK library APIs and the platform porting layer APIs to perform MQTT publish/subscribe operations.</para><para><bold>Library link:</bold> <ulink url="https://github.com/aws/aws-iot-device-sdk-embedded-C/tree/v4_beta">https://github.com/aws/aws-iot-device-sdk-embedded-C/tree/v4_beta</ulink></para>
<para><bold>AWS IoT Device SDK C - v4.0.0</bold></para>
<para>This is an open source MQTT library developed and maintained by Amazon. This library implements the core MQTT protocol logic.</para><para><itemizedlist>
<listitem><para>"AWS IoT Device SDK C v4.0.0" library provides following features:<itemizedlist>
<listitem><para>MQTT 3.1.1 client</para></listitem><listitem><para>Asynchronous API for MQTT operations.</para></listitem><listitem><para>Multithreaded API by default.</para></listitem><listitem><para>Complete separation of MQTT and network stack, allowing MQTT to run on top of any network stack.</para></listitem><listitem><para>Configurable memory allocation (static-only or dynamic). Memory allocation functions may also be set by the user.</para></listitem><listitem><para>MQTT persistent session support.</para></listitem><listitem><para>Supports Quality of Service (QoS) levels 0 and 1</para></listitem><listitem><para>Supports MQTT connection over both secured and non secured TCP connections.</para></listitem></itemizedlist>
</para></listitem></itemizedlist>
</para>

<para><bold>Platform Porting Layer</bold></para>
<para>This portable layer provides the APIs that are required for 'AWS IoT Device SDK library' to perform OS and Network related operations on the Cypress platform. This layer contains APIs that are used for creating thread, mutex, timers, etc. And it also contains APIs to establish secure/non-secure socket connections with MQTT broker to send and receive MQTT messages.</para>


<para><heading level="1">Supported Platforms</heading></para>
<para>This library and its features are supported on following Cypress platforms:<itemizedlist>
<listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/psoc-6-wi-fi-bt-prototyping-kit-cy8cproto-062-4343w">PSoC6 WiFi-BT Prototyping Kit (CY8CPROTO-062-4343W)</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/psoc-62s2-wi-fi-bt-pioneer-kit-cy8ckit-062s2-43012">PSoC 62S2 Wi-Fi BT Pioneer Kit (CY8CKIT-062S2-43012)</ulink></para></listitem></itemizedlist>
</para>

<para><heading level="1">Dependent libraries</heading></para>
<para>This MQTT client library depends on the following libraries. Both these libraries are included by default.<itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core">Wi-Fi Middleware Core</ulink></para></listitem><listitem><para><ulink url="https://github.com/aws/aws-iot-device-sdk-embedded-C/tree/v4_beta/libraries/standard/mqtt">AWS IoT Device SDK MQTT library</ulink></para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick start</heading></para>
<para><itemizedlist>
<listitem><para>A "reasonable amount of time" to wait for keep-alive responses from the MQTT broker is configured using IOT_MQTT_RESPONSE_WAIT_MS in <ulink url="../../../_static/file/api/iot-middleware/MQTT/iot_config.h">iot_config.h</ulink>. This value may be adjusted to suit the use case and network environment.</para></listitem><listitem><para>The reference <ulink url="../../../_static/file/api/iot-middleware/MQTT/iot_config.h">iot_config.h</ulink> that is bundled with this library provides the configurations required for <ulink url="https://github.com/aws/aws-iot-device-sdk-embedded-C/tree/v4_beta/libraries/standard/mqtt">AWS IoT Device SDK</ulink> library. The application must copy this file to the root directory where the application Makefile is present, and suitably adjust the default settings.</para></listitem><listitem><para>This MQTT client library does not support secure connections to the public test.mosquitto.org broker by default, as the server uses SHA1 hashing algorithm. As cautioned by mbedTLS, SHA-1 is considered a weak message digest and is therefore not enabled by default by mbedTLS. The use of SHA-1 for certificate signing constitutes a security risk. It is recommended to avoid dependencies on it, and consider stronger message digests instead. However, if it is desired to connect securely to test.mosquitto.org, follow these steps to enable support:<orderedlist>
<listitem><para>Define the below macro in your application: <programlisting><codeline><highlight class="normal">CY_MQTT_ENABLE_SECURE_TEST_MOSQUITTO_SUPPORT<sp /><sp /></highlight></codeline>
</programlisting></para></listitem><listitem><para>Enable SHA1 support in mbedTLS by defining the below macro in wifi-mw-core/configs/mbedtls_user_config.h: <programlisting><codeline><highlight class="normal">#define<sp />MBEDTLS_TLS_DEFAULT_ALLOW_SHA1_IN_CERTIFICATES<sp /><sp /></highlight></codeline>
</programlisting></para></listitem></orderedlist>
</para></listitem><listitem><para>A set of pre-defined configuration files have been bundled with wifi-mw-core library for FreeRTOS, LwIP and MbedTLS. The developer is expected to review the configuration and make adjustments. Refer to the Quick start section in <ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core/blob/master/README.md">README.md</ulink> for more details</para></listitem><listitem><para>A set of COMPONENTS have to be defined in the code example project's Makefile for MQTT library. Refer to the Quick start section in <ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core/blob/master/README.md">README.md</ulink> for more details</para></listitem><listitem><para>Configure the following macros defined in cyport/include/iot_config.h file to enable/disable debug logs in this library: <programlisting><codeline><highlight class="normal">#define<sp />IOT_LOG_LEVEL_GLOBAL<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />IOT_LOG_LEVEL_DEMO<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />IOT_LOG_LEVEL_PLATFORM<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />IOT_LOG_LEVEL_NETWORK<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />IOT_LOG_LEVEL_TASKPOOL<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />IOT_LOG_LEVEL_MQTT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />AWS_IOT_LOG_LEVEL_SHADOW<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />AWS_IOT_LOG_LEVEL_DEFENDER<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
<codeline><highlight class="normal">#define<sp />AWS_IOT_LOG_LEVEL_JOBS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IOT_LOG_ERROR</highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Code Snippet 1: Initialize MQTT and dependent libraries</bold></para>
<para>This code snippet demonstrates the initialization of the various libraries like the AWS IoT device SDK, Cypress secure sockets, and the AWS IoT MQTT. <programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_mqtt_init(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Status<sp />variables<sp />for<sp />various<sp />operations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotNetworkError_t<sp />networkStatus<sp />=<sp />IOT_NETWORK_SUCCESS;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttError_t<sp />mqttStatus<sp />=<sp />IOT_MQTT_SUCCESS;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />AWS<sp />IoT<sp />device<sp />SDK<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotSdk_Init();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />Cypress<sp />Secure<sp />Sockets<sp />library<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />networkStatus<sp />=<sp /><ref kindref="member" refid="group__mqtt__cyport__function_1ga79702091072df13f4ec2efbc5c083333">IotNetworkSecureSockets_Init</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />MQTT<sp />library<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />mqttStatus<sp />=<sp />IotMqtt_Init();</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>Code Snippet 2: Non Secure connection to MQTT broker</bold></para>
<para>This code snippet demonstrates the initialization of configuration structures required for a non-secure MQTT connection and the usage of IotMqtt_Connect() API. <programlisting><codeline><highlight class="comment">/*<sp />MQTT<sp />Broker/Server<sp />address<sp />and<sp />port<sp />used<sp />for<sp />the<sp />MQTT<sp />connection<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_BROKER_ADDRESS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"&lt;MQTT-BROKER-ADDRESS&gt;"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_PORT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />1883</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Every<sp />active<sp />MQTT<sp />connection<sp />must<sp />have<sp />a<sp />unique<sp />client<sp />identifier.</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Note:<sp />The<sp />longest<sp />client<sp />identifier<sp />that<sp />an<sp />MQTT<sp />server<sp />must<sp />accept<sp />(as<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp />defined<sp />by<sp />the<sp />MQTT<sp />3.1.1<sp />spec)<sp />is<sp />23<sp />characters.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_CLIENT_IDENTIFIER<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"psoc6-mqtt-client"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />timeout<sp />in<sp />milliseconds<sp />for<sp />the<sp />MQTT<sp />operations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_TIMEOUT_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(5000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />keep-alive<sp />interval<sp />in<sp />seconds<sp />used<sp />for<sp />MQTT<sp />ping<sp />request<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_KEEP_ALIVE_SECONDS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(60)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_mqtt_connection(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Status<sp />variable<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttError_t<sp />result<sp />=<sp />IOT_MQTT_SUCCESS;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />MQTT<sp />connection<sp />handle<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttConnection_t<sp />mqttConnection<sp />=<sp />IOT_MQTT_CONNECTION_INITIALIZER;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />structure<sp />with<sp />the<sp />MQTT<sp />Broker/Server<sp />details<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">IotNetworkServerInfo<sp />networkServerInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pHostName<sp />=<sp />MQTT_BROKER_ADDRESS,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.port<sp />=<sp />MQTT_PORT</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />structure<sp />with<sp />the<sp />network<sp />interface<sp />details<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttNetworkInfo_t<sp />networkInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.createNetworkConnection<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.u.setup.pNetworkCredentialInfo<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.u.setup.pNetworkServerInfo<sp />=<sp />&amp;networkServerInfo,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pNetworkInterface<sp />=<sp />IOT_NETWORK_INTERFACE_CY_SECURE_SOCKETS</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />structure<sp />with<sp />the<sp />MQTT<sp />connection<sp />information<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttConnectInfo_t<sp />connectionInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.cleanSession<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.awsIotMqttMode<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.keepAliveSeconds<sp />=<sp />MQTT_KEEP_ALIVE_SECONDS,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pClientIdentifier<sp />=<sp />MQTT_CLIENT_IDENTIFIER,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.clientIdentifierLength<sp />=<sp />strlen(MQTT_CLIENT_IDENTIFIER),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pWillInfo<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pUserName<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pPassword<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.userNameLength<sp />=<sp />0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.passwordLength<sp />=<sp />0</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp />IotMqtt_Connect(&amp;networkInfo,<sp />&amp;connectionInfo,<sp />MQTT_TIMEOUT_MS,<sp />&amp;mqttConnection);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>Code Snippet 3: Secure connection to MQTT broker</bold></para>
<para>This code snippet demonstrates the initialization of configuration structures required for a secure MQTT connection and the usage of IotMqtt_Connect() API. <programlisting><codeline><highlight class="comment">/*<sp />MQTT<sp />Broker/Server<sp />address<sp />and<sp />port<sp />used<sp />for<sp />the<sp />MQTT<sp />connection<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_BROKER_ADDRESS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"&lt;MQTT-BROKER-ADDRESS&gt;"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_PORT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />8883</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Every<sp />active<sp />MQTT<sp />connection<sp />must<sp />have<sp />a<sp />unique<sp />client<sp />identifier.</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Note:<sp />The<sp />longest<sp />client<sp />identifier<sp />that<sp />an<sp />MQTT<sp />server<sp />must<sp />accept<sp />(as<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp />defined<sp />by<sp />the<sp />MQTT<sp />3.1.1<sp />spec)<sp />is<sp />23<sp />characters.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_CLIENT_IDENTIFIER<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"psoc6-mqtt-client"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Set<sp />this<sp />macro<sp />to<sp />'true'<sp />if<sp />the<sp />MQTT<sp />Broker<sp />being<sp />used<sp />is<sp />hosted<sp />by<sp />AWS<sp />IoT<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Core<sp />service,<sp />else<sp />'false'</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />AWS_IOT_MQTT_MODE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(<sp />true<sp />)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />timeout<sp />in<sp />milliseconds<sp />for<sp />the<sp />MQTT<sp />operations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_TIMEOUT_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(5000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />keep-alive<sp />interval<sp />in<sp />seconds<sp />used<sp />for<sp />MQTT<sp />ping<sp />request<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_KEEP_ALIVE_SECONDS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(60)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />the<sp />below<sp />credentials<sp />for<sp />a<sp />secure<sp />connection<sp />with<sp />the<sp />MQTT<sp />Broker<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />PEM-encoded<sp />client<sp />certificate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />CLIENT_CERTIFICATE<sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"-----BEGIN<sp />CERTIFICATE-----\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"........base64<sp />data........\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"-----END<sp />CERTIFICATE-----"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />PEM-encoded<sp />client<sp />private<sp />key<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />CLIENT_PRIVATE_KEY<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"-----BEGIN<sp />RSA<sp />PRIVATE<sp />KEY-----\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"..........base64<sp />data..........\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"-----END<sp />RSA<sp />PRIVATE<sp />KEY-----"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />PEM-encoded<sp />Root<sp />CA<sp />certificate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />ROOT_CA_CERTIFICATE<sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"-----BEGIN<sp />CERTIFICATE-----\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"........base64<sp />data........\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"-----END<sp />CERTIFICATE-----"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_mqtt_secure_connection(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Status<sp />variable<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttError_t<sp />result<sp />=<sp />IOT_MQTT_SUCCESS;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />MQTT<sp />connection<sp />handle<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttConnection_t<sp />mqttConnection<sp />=<sp />IOT_MQTT_CONNECTION_INITIALIZER;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />structure<sp />with<sp />the<sp />MQTT<sp />Broker/Server<sp />details<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">IotNetworkServerInfo<sp />networkServerInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pHostName<sp />=<sp />MQTT_BROKER_ADDRESS,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.port<sp />=<sp />MQTT_PORT</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />structue<sp />to<sp />store<sp />the<sp />MQTT<sp />client<sp />credentials<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">IotNetworkCredentials<sp />credentials<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{<sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pClientCert<sp />=<sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*)CLIENT_CERTIFICATE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.clientCertSize<sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(CLIENT_CERTIFICATE),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pPrivateKey<sp />=<sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*)CLIENT_PRIVATE_KEY,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.privateKeySize<sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(CLIENT_PRIVATE_KEY),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pRootCa<sp />=<sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*)ROOT_CA_CERTIFICATE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.rootCaSize<sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(ROOT_CA_CERTIFICATE),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pAlpnProtos<sp />=<sp />NULL</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />structure<sp />with<sp />the<sp />network<sp />interface<sp />details<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttNetworkInfo_t<sp />networkInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.createNetworkConnection<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.u.setup.pNetworkCredentialInfo<sp />=<sp />&amp;credentials,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.u.setup.pNetworkServerInfo<sp />=<sp />&amp;networkServerInfo,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pNetworkInterface<sp />=<sp />IOT_NETWORK_INTERFACE_CY_SECURE_SOCKETS</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />structure<sp />with<sp />the<sp />MQTT<sp />connection<sp />information<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttConnectInfo_t<sp />connectionInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.cleanSession<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.awsIotMqttMode<sp />=<sp />AWS_IOT_MQTT_MODE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.keepAliveSeconds<sp />=<sp />MQTT_KEEP_ALIVE_SECONDS,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pClientIdentifier<sp />=<sp />MQTT_CLIENT_IDENTIFIER,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.clientIdentifierLength<sp />=<sp />strlen(MQTT_CLIENT_IDENTIFIER),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pWillInfo<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pUserName<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pPassword<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.userNameLength<sp />=<sp />0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.passwordLength<sp />=<sp />0</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp />IotMqtt_Connect(&amp;networkInfo,<sp />&amp;connectionInfo,<sp />MQTT_TIMEOUT_MS,<sp />&amp;mqttConnection);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>Code Snippet 4: Operation completion callback</bold></para>
<para>MQTT operation completion callback function. Checks for valid parameters and unblocks the waiting thread. <programlisting><codeline><highlight class="comment">/*<sp />The<sp />structure<sp />used<sp />by<sp />the<sp />MQTT<sp />operation<sp />callback<sp />function<sp />common<sp />to<sp />all<sp />the<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />asynchronous<sp />APIs<sp />to<sp />unblock<sp />the<sp />waiting<sp />thread</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">mqttOperationCompleteParams</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttOperationType_t<sp />expectedOperation;<sp /></highlight><highlight class="comment">/*<sp />Expected<sp />completed<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />SemaphoreHandle_t<sp />waitSem;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Used<sp />to<sp />unblock<sp />waiting<sp />test<sp />thread<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttOperation_t<sp />operation;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reference<sp />to<sp />expected<sp />completed<sp />operation<sp />*/</highlight></codeline>
<codeline><highlight class="normal">}<sp />mqttOperationCompleteParams_t;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mqttOperationCallback(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*<sp />pArgument,<sp />IotMqttCallbackParam_t<sp />*<sp />pOperation)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />mqttOperationCompleteParams_t<sp />*<sp />pParams<sp />=<sp />(mqttOperationCompleteParams_t<sp />*)<sp />pArgument;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />the<sp />operation<sp />information<sp />matches<sp />the<sp />parameters<sp />and<sp />the<sp />operation<sp />was</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />successful,<sp />unblock<sp />the<sp />waiting<sp />thread</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">((pParams-&gt;expectedOperation<sp />==<sp />pOperation-&gt;u.operation.type)<sp />&amp;&amp;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp />(pParams-&gt;operation<sp />==<sp />pOperation-&gt;u.operation.reference)<sp />&amp;&amp;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp />(pOperation-&gt;u.operation.result<sp />==<sp />IOT_MQTT_SUCCESS))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />xSemaphoreGive(pParams-&gt;waitSem);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>Code Snippet 5: MQTT message publish</bold></para>
<para>This code snippet demonstrates the initialization of the publish message information structure and the usage of IotMqtt_PublishAsync() API. <programlisting><codeline><highlight class="comment">/*<sp />The<sp />timeout<sp />in<sp />milliseconds<sp />for<sp />the<sp />MQTT<sp />operations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_TIMEOUT_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(5000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />MQTT<sp />topic<sp />on<sp />which<sp />the<sp />messages<sp />will<sp />be<sp />published<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />PUBLISH_MQTT_TOPIC<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"myMqttTopic"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />MQTT<sp />message<sp />that<sp />will<sp />be<sp />published<sp />on<sp />the<sp />above<sp />mentioned<sp />topic<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_PUBLISH_MESSAGE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"Hello<sp />World!"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Set<sp />the<sp />QoS<sp />that<sp />is<sp />associated<sp />with<sp />the<sp />MQTT<sp />publish<sp />messages.</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Valid<sp />choices<sp />are<sp />0,<sp />and<sp />1.<sp />The<sp />MQTT<sp />library<sp />currently<sp />does<sp />not<sp />support<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />QoS<sp />2,<sp />and<sp />hence<sp />should<sp />not<sp />be<sp />used<sp />in<sp />this<sp />macro.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_MESSAGES_QOS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(<sp />1<sp />)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />maximum<sp />number<sp />of<sp />times<sp />each<sp />Publish<sp />operation<sp />will<sp />be<sp />retried<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />PUBLISH_RETRY_LIMIT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(10)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />A<sp />Publish<sp />message<sp />is<sp />retried<sp />if<sp />no<sp />response<sp />is<sp />received<sp />within<sp />this<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />time<sp />(in<sp />milliseconds)</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />PUBLISH_RETRY_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_mqtt_publish(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Status<sp />variable<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttError_t<sp />result<sp />=<sp />IOT_MQTT_SUCCESS;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />callback<sp />function<sp />and<sp />parameter<sp />information<sp />required<sp />to<sp />unblock</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />this<sp />thread<sp />after<sp />the<sp />asynchronous<sp />Publish<sp />operation<sp />is<sp />complete</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />mqttOperationCompleteParams_t<sp />callbackParam<sp />=<sp />{<sp />.expectedOperation<sp />=<sp />IOT_MQTT_PUBLISH_TO_SERVER<sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttCallbackInfo_t<sp />callbackInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.function<sp />=<sp />mqttOperationCallback,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pCallbackContext<sp />=<sp />&amp;callbackParam</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Structure<sp />to<sp />store<sp />publish<sp />message<sp />information<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttPublishInfo_t<sp />publishInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.qos<sp />=<sp />MQTT_MESSAGES_QOS,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pTopicName<sp />=<sp />PUBLISH_MQTT_TOPIC,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.topicNameLength<sp />=<sp />strlen(PUBLISH_MQTT_TOPIC),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.retryMs<sp />=<sp />PUBLISH_RETRY_MS,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.retryLimit<sp />=<sp />PUBLISH_RETRY_LIMIT,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pPayload<sp />=<sp />MQTT_PUBLISH_MESSAGE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.payloadLength<sp />=<sp />strlen(MQTT_PUBLISH_MESSAGE)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Create<sp />a<sp />binary<sp />semaphore<sp />used<sp />to<sp />block<sp />this<sp />thread<sp />until<sp />the<sp />callback</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />'mqttOperationCallback()'<sp />gives<sp />the<sp />semaphore<sp />to<sp />unblock<sp />the<sp />thread</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />callbackParam.waitSem<sp />=<sp />xSemaphoreCreateBinary();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Publish<sp />the<sp />MQTT<sp />message<sp />with<sp />the<sp />configured<sp />parameters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp />IotMqtt_PublishAsync(mqttConnection,<sp />&amp;publishInfo,<sp />0,<sp />&amp;callbackInfo,<sp />&amp;(callbackParam.operation));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />the<sp />Publish<sp />operation<sp />to<sp />complete<sp />for<sp />at<sp />most<sp />'MQTT_TIMEOUT_MS'</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />milliseconds</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(xSemaphoreTake(callbackParam.waitSem,<sp />pdMS_TO_TICKS(MQTT_TIMEOUT_MS))<sp />==<sp />pdTRUE)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Publish<sp />operation<sp />successful<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Destroy<sp />the<sp />waiting<sp />semaphore<sp />after<sp />the<sp />Publish<sp />operation<sp />is<sp />executed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />vSemaphoreDelete(callbackParam.waitSem);<sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>Code Snippet 6: Subscribed message received callback</bold></para>
<para>Callback to handle incoming MQTT messages from the broker. <programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mqttSubscriptionCallback(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*pCallbackContext,<sp />IotMqttCallbackParam_t<sp />*pPublishInfo)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />MQTT<sp />message<sp />payload<sp />received<sp />from<sp />the<sp />broker<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*receivedMqttMessage<sp />=<sp />pPublishInfo-&gt;u.message.info.pPayload;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />receivedMqttMessageLength<sp />=<sp />pPublishInfo-&gt;u.message.info.payloadLength;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />subscription<sp />topic<sp />filter<sp />that<sp />matched<sp />the<sp />received<sp />message<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*subscriptionTopicFilter<sp />=<sp />pPublishInfo-&gt;u.message.pTopicFilter;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />subscriptionTopicFilterLength<sp />=<sp />pPublishInfo-&gt;u.message.topicFilterLength;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />MQTT<sp />topic<sp />on<sp />which<sp />the<sp />message<sp />was<sp />published<sp />to<sp />the<sp />broker<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*publishedTopicName<sp />=<sp />pPublishInfo-&gt;u.message.info.pTopicName;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />publishedTopicNameLength<sp />=<sp />pPublishInfo-&gt;u.message.info.topicNameLength;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />QoS<sp />of<sp />the<sp />published<sp />message<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttQos_t<sp />publishedMessageQos<sp />=<sp />pPublishInfo-&gt;u.message.info.qos;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>Code Snippet 7: MQTT message subscribe</bold></para>
<para>This code snippet demonstrates the initialization of the subscription information structure and the usage of IotMqtt_SubscribeAsync() API. <programlisting><codeline><highlight class="comment">/*<sp />The<sp />timeout<sp />in<sp />milliseconds<sp />for<sp />the<sp />MQTT<sp />operations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_TIMEOUT_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(5000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />MQTT<sp />topic<sp />to<sp />be<sp />subscribed<sp />to<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SUBSCRIBE_MQTT_TOPIC<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"myMqttTopic"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />number<sp />of<sp />MQTT<sp />topics<sp />to<sp />be<sp />subscribed<sp />to<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SUBSCRIPTION_COUNT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Set<sp />the<sp />QoS<sp />that<sp />is<sp />associated<sp />with<sp />the<sp />MQTT<sp />subscribe<sp />messages.</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Valid<sp />choices<sp />are<sp />0,<sp />and<sp />1.<sp />The<sp />MQTT<sp />library<sp />currently<sp />does<sp />not<sp />support<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />QoS<sp />2,<sp />and<sp />hence<sp />should<sp />not<sp />be<sp />used<sp />in<sp />this<sp />macro.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_MESSAGES_QOS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(<sp />1<sp />)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_mqtt_subscribe(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Status<sp />variable<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttError_t<sp />result<sp />=<sp />IOT_MQTT_SUCCESS;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />callback<sp />function<sp />and<sp />parameter<sp />information<sp />required<sp />to<sp />unblock<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />this<sp />thread<sp />after<sp />the<sp />asynchronous<sp />Subscribe<sp />operation<sp />is<sp />complete</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />mqttOperationCompleteParams_t<sp />callbackParam<sp />=<sp />{<sp />.expectedOperation<sp />=<sp />IOT_MQTT_SUBSCRIBE<sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttCallbackInfo_t<sp />callbackInfo<sp />=<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.function<sp />=<sp />mqttOperationCallback,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pCallbackContext<sp />=<sp />&amp;callbackParam</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Structure<sp />to<sp />store<sp />subscription<sp />information<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqttSubscription_t<sp />subscribeInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.qos<sp />=<sp />MQTT_MESSAGES_QOS,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pTopicFilter<sp />=<sp />SUBSCRIBE_MQTT_TOPIC,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.topicFilterLength<sp />=<sp />strlen(SUBSCRIBE_MQTT_TOPIC),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.callback.function<sp />=<sp />mqttSubscriptionCallback</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Create<sp />a<sp />binary<sp />semaphore<sp />used<sp />to<sp />block<sp />this<sp />thread<sp />until<sp />the<sp />callback</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />'mqttOperationCallback()'<sp />gives<sp />the<sp />semaphore<sp />to<sp />unblock<sp />the<sp />thread</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />callbackParam.waitSem<sp />=<sp />xSemaphoreCreateBinary();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />with<sp />the<sp />configured<sp />parameters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp />IotMqtt_SubscribeAsync(mqttConnection,<sp />&amp;subscribeInfo,<sp />SUBSCRIPTION_COUNT,<sp />0,<sp />&amp;callbackInfo,<sp />&amp;(callbackParam.operation));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />the<sp />Subscribe<sp />operation<sp />to<sp />complete<sp />for<sp />at<sp />most<sp />'MQTT_TIMEOUT_MS'</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />milliseconds</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(xSemaphoreTake(callbackParam.waitSem,<sp />pdMS_TO_TICKS(MQTT_TIMEOUT_MS))<sp />==<sp />pdTRUE)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />operation<sp />successful<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Destroy<sp />the<sp />waiting<sp />semaphore<sp />after<sp />the<sp />Subscribe<sp />operation<sp />is<sp />executed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />vSemaphoreDelete(callbackParam.waitSem);<sp /></highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>